/************************************************************
SPI Master ber AVR USI Schnittstelle     6.12.2006 A.Schnell
ACHTUNG USI WIRD VON AVR STUDIO NICHT UNTERSTTZT!
*************************************************************/

#include <tiny2313.h>

void init(void)
{
CLKPR=0x80;       // Crystal Oscillator division factor: 1
PORTB=0b00001000; // SS_Enable zunchst High
DDRB =0b11001000; // PB7:SCLK output, PB6:MOSI output!!, PB5:MISO Input, PB3:SS_Enable output, 
USICR=0x10;       // USI initialization, Mode: Three Wire (SPI), no clock,  no USI counter int
ACSR=0x80;
}   

#pragma warn- // this will prevent warnings  (unused data and return value )
unsigned char spi_master(unsigned char data)
{ 
#asm
.equ USICR=0x0d                 ;USI control register
.equ USISR=0x0e                 ;USI status register
.equ USIDR=0x0f 		;USI data = shift register
.equ USIOIF=6                   ;Bitcounter overflow flag bit in USI statusregister
.equ USIWM0=4			;WM1: 0 WM0: 1  Three wire mode
.equ USICS1=3                   ;CS1: 1 CS0: 0  CLK:1 External,pos.edge software clock USITC
.equ USICS0=2
.equ USICLK=1
.equ USITC=0                    ;TC writing a one to this bit toogles clock

    ld  r26,y   		;R26 <= data, value to be transfered to slave
    out USIDR,r26               ;into spi shiftregister  

    ldi r26,(1<<USIOIF)		;set spi bitcounter overflowflag
    out USISR,r26               ;cleared in spi status register

    ;set three wire mode (spi), positive edge shift, count at USITC strobe, Toggle USCK 			 
    ldi r26,(1<<USIWM0) |  (1<<USICLK) | (1<<USITC)  | (1<<USICS1)
sl: out USICR,r26               ;control bits in spi control register, shift and clock generation
    sbis USISR,USIOIF           ;finish if counter flag signals 16 clock edges
    rjmp sl                     ;loop 8 times for 8 Bits
    in  r30,USIDR               ;latch byte from slave into r30 as return value  
#endasm
}
#pragma warn+ // enable warnings 


void main(void)
{ unsigned char fromslave1,toslave1; 
  init();
  
  while (1)
  { 
   PORTB.3 = 0;  // SS_Enable Low    
   fromslave1 = spi_master(toslave1);
   // fromslave2 = spi_master(toslave2);
   // Bei mehreren Schieberegistern die in Reihe geschaltet sind spi_master()
   // entsprechend mehrfach aufrufen und Zwischenergebnisse speichern
   PORTB.3 = 1;  // SS_Enable High
  };
}
